#!/usr/bin/env ruby

require 'bundler/setup'

require './TrueLegacyGraphicsOpenGL'

# ffmpeg -y -i tetran.d/3dtetran%06d.png -vcodec libx264 -r 30 -s 480x360 tetran.mp4
Dir.mkdir(@path = 'tetran.d') rescue true
win = LegacyGraphics.new(nil, nil, nil, nil, 720, 960, 16, 8, 0, { :file => 'tetran', :type => 'png' })	# png/pdf/svg/ps

@hands = 4; @swing = 1440
def draw_sprites(win, f)
win.depth3d(0, 16)
win = win.init_sprites
win.tPenUp
win.tSetPenColor([0.6, 0.6, 0.6])
win.tSetPenWidth(16)
@hands.times {|n|
	win.tHome
	win.tRight(f * 3)
	win.tRight(n * 360 / @hands)
	9.times {|n|
		win.tPenDown unless(n < 2)
		win.tForward(32)
		win.tPenUp
		win.tForward(6)
		win.tRight(4 + @swing)
	}
}
end
draw_sprites(win, 0)

def callback(win, info, params)
	case(info[0])
	  when(:VSYNC)
		while(it = win.inputs[:EDGE].shift)
			it == 'h' and @hands += 1
			it == 's' and @swing = 0
			it == 'r' and @ar = win.arotate3d(@ar ? 0 : 1)
			it == 'q' and exit
		end
#		win.write_to_file(@path + '/3dtetran%06d.png' % ($jiffies - 1))
		@swing < 1440 and @swing += 2
	end
	draw_sprites(win, $jiffies)
end
win.setcallback3d(method(:callback).to_proc, {})

win.depth3d(32)
ox = win.gx / 2; oy = win.gy / 2
win.put_image_png(ox - 96, oy - 96, 'tetran0.png')

win.arotate3d(@ar = 1)
win.refresh(30)
win.close

__END__

